import JSZip from 'jszip';
import { ElementType } from '../enums/element-type';
export declare type SlideModificationCallback = (document: Document) => void;
export declare type ShapeModificationCallback = (XMLDocument: XMLDocument, arg1?: Document, arg2?: Workbook) => void;
export declare type GetRelationshipsCallback = (element: Element, rels: Target[]) => void;
export declare type AutomizerParams = {
    /**
     * Prefix for all template files. You can set a path here.
     */
    templateDir?: string;
    /**
     * Prefix for the output files for `Automizer` instance.
     * You can set a path here.
     */
    outputDir?: string;
};
export declare type AutomizerSummary = {
    status: string;
    duration: number;
    file: string;
    templates: number;
    slides: number;
    charts: number;
    images: number;
};
export declare type Target = {
    file: string;
    number?: number;
    rId?: string;
};
export declare type ImportElement = {
    presName: string;
    slideNumber: number;
    selector: string;
    mode: string;
    callback?: ShapeModificationCallback | ShapeModificationCallback[];
};
export declare type ImportedElement = {
    mode: string;
    name?: string;
    sourceArchive: JSZip;
    sourceSlideNumber: number;
    callback?: ImportElement['callback'];
    target?: AnalyzedElementType['target'];
    type?: AnalyzedElementType['type'];
    sourceElement?: AnalyzedElementType['element'];
};
export declare type AnalyzedElementType = {
    type: ElementType;
    target?: Target;
    element?: XMLDocument;
};
export declare type TargetByRelIdMapParam = {
    relRootTag: string;
    relAttribute: string;
    prefix: string;
    expression?: RegExp;
};
export declare type Workbook = {
    archive: JSZip;
    sheet: XMLDocument;
    sharedStrings: XMLDocument;
    table: XMLDocument;
};
